%dbstop in sectar at 27
%cd 'C:\Biophysics\ANDREY\MODELING\Molecules\Data'
cd 'C:\Andrey\Other-\Matlab\Molecules\Data'
s=[];
[s,v]=uigetfiles('*.tif; *.bmp','Select an image file:');

if ~isempty(s)
    %set(findobj(1,'Tag','d_file'),'String',f{s(1)});
    for m=1:length(s)
	PaperBands=1;	%Flag for the presense of paper bands between protein bands
	GelImage=double(imread(s{m}));	%=================Reads Crossection image file
	GelImage=max(max(max(GelImage)))-GelImage;	%Inversing gel image to have black spots as big numbers.
	disp(['File: ',s{m}]);
	disp([num2str(size(GelImage)), ' image read']);
	Back=GelImage(1,1,:);	%Background color - left top pixel
	
	%==============Define if there are borders of another color separating columns
	%for border color to be defined in the first line of image here...
	%should be ONLY background and border color points
	
	FirstLine=GelImage(1,:,:);	%First line of the image
	
	Border=[];	%Color for border
	TotCol=size(FirstLine,2);	%total number of columns
	for i=1:TotCol	%Search for non-background pixels
	    if FirstLine(1,i,:)~=Back	%Point of non-background color
		if isempty(Border)	%First pixel met
		    Border=FirstLine(1,i,:);
		    msg='Border detected';
		else	%there was first border pixel
		    if FirstLine(1,i,:)~=Border	%new non-background pixel is not of Board color.
			Border=Back; % Board is set to background
			msg='Border not detected';
			break
		    end
		end
	    end
	end
	
	if isempty(Border); Border=Back; msg='Border not detected'; end	%There were no non-background pixels. Border set to Background
	disp(msg);
	
	%=============== Counting columns
	Position=round(size(GelImage,1)/2);	%half-height of image
	GelLine=GelImage(Position,:,:);	%Current line of the image
	BandsNumb=0;	%Gel Bands number
	BrdNow=1;	%flag of moving through border or background
	
	for i=2:(TotCol)	%Cycle through columns
	    if BrdNow==1	%previous point is border
		if (GelLine(1,i,:)~=Border)	%current point is part of gel
		    BrdNow=0;	%flag is "not a border"
		    BandsNumb=BandsNumb+1;	%one more gel column
		end
	    else	%previous point is gel
		if (GelLine(1,i,:)==Border)	%current point is part of border
		    BrdNow=1;	%flag is " border"
		end
	    end
	end
	
	disp([num2str(BandsNumb),' bands counted (total)']);
	
	%================Assigning column types - protein(1) or paper(0)
	BandType=ones(1,BandsNumb);	%All bands marked as protein
	if round(BandsNumb/2)==BandsNumb/2|PaperBands==0	%Odd number of bands - there are no paper bands
	    PaperBands=0;
	else	%Paper bands are present
	    % 	    if PaperBands==1
	    BandType(1:2:BandsNumb)=0;	%Paper bands are with odd numbers
	    % 	    else	%No paper bands
	    % 	    end
	    
	end
	disp([num2str(length(find(BandType==1))), ' protein bands supposed']);
	
	%================Counting protein amount
	
	
	disp('Calculating mean optical density...');
	BandVal=zeros(size(GelImage,1),BandsNumb);	%Temporal band value matrix - will be assigned to the paper or protein
	BandPoints=zeros(size(GelImage,1),BandsNumb);	%Temporal band's #of points matrix - will be assigned to the paper or protein
	
	for Position=1:size(GelImage,1);	%Cycle through the image lines and forming bands matrix - ...
	    %each band is represented as 2 columns - one with sum of point values, and 2nd - number of points counted in this band in this line
	    BandN=0;	%Number of current band
	    GelLine=GelImage(Position,:,:);	%Current line of the image
	    BrdNow=1;	%flag of moving through border or background
	    for i=2:(TotCol)	%Cycle through columns
		if BrdNow==1	%previous point is border
		    if (GelLine(1,i,:)~=Border)	%cur. point is part of gel. Beginning of counting
			BrdNow=0;	%flag is "not a border or background"
			BandN=BandN+1;	%one more gel band
			if (GelLine(1,i,:)~=Back)	%Not a background
			    BandVal(Position,BandN)=sum(GelLine(1,i,:));
			    BandPoints(Position,BandN)=1;
			end
		    end
		else	%previous point is gel
		    if (GelLine(1,i,:)==Border)	%current point is part of border or background. End of counting
			BrdNow=1;	%flag is " border or background"
			
			%----assigning values 
		    elseif (GelLine(1,i,:)~=Back)	%Continuing poins counting for the current piece
			BandVal(Position,BandN)=BandVal(Position,BandN)+sum(GelLine(1,i,:));
			BandPoints(Position,BandN)=BandPoints(Position,BandN)+1;
		    end
		end
	    end
	end
	% 		BandVal	
	% 		BandPoints
	
	%=======Recalculating and normalizing protein content
	if PaperBands==1	%Paper bands are present
	    disp('Substracting background...');
	    BandValFin=[];
	    for Position=1:size(GelImage,1);	%Cycle through the bands lines and forming bands final values
		for BandN=1:2:BandsNumb	%Cycle through paper bands
		    if BandPoints(Position,BandN)>0	%there are some points in the bin
			BandValFin(Position,BandN)=BandVal(Position,BandN)/BandPoints(Position,BandN);	%Mean paper value
		    else
			BandValFin(Position,BandN)=NaN;
		    end
		end
	    end
	    
	    %---interpolate paper bands
	    for BandN=1:2:BandsNumb	%Cycle through paper bands
		BandValFin(:,BandN)=(interp1AGB(find(~isnan(BandValFin(:,BandN))),BandValFin(~isnan(BandValFin(:,BandN)),BandN),...
		    1:size(GelImage,1)))';
	    end

	    %---Calculate protein amount
	    for Position=1:size(GelImage,1);	%Cycle through the bands lines and forming bands final values
		for BandN=2:2:BandsNumb	%Cycle through protein bands
		    if (BandPoints(Position,BandN)>0)%&max(BandPoints(Position,BandN-1),BandPoints(Position,BandN+1))>0
			%There are some points in protein and some in background
			BandValFin(Position,BandN)=BandVal(Position,BandN)-(BandValFin(Position,BandN-1)+...
			    BandValFin(Position,BandN+1))*BandPoints(Position,BandN)/2;	%Absolute protein value=...
			%=absolute protein+paper value - interpolated absolute paper value.
		    else
			BandValFin(Position,BandN)=NaN;
		    end
		end
	    end
	else	%No paper bands
	    disp('Averaging by band width...');
	    BandValFin=[];
	    for Position=1:size(GelImage,1);	%Cycle through the bands lines and forming bands final values
		for BandN=1:BandsNumb	%Cycle through paper bands
		    if BandPoints(Position,BandN)>0	%there are some points in the bin
			BandValFin(Position,BandN)=BandVal(Position,BandN)/BandPoints(Position,BandN);	%Mean paper value
		    else
			BandValFin(Position,BandN)=NaN;
		    end
		end
	    end
	end
	% 		BandValFin
	
	%=============Writing results to the file
	fidProt=fopen([s{m},'_prot.txt'],'w');
	fidVal=fopen([s{m},'_val.txt'],'w');
	fidPoints=fopen([s{m},'_points.txt'],'w');
	disp(['File: ',s{m},' finished!']);
	disp('________________');

	for Position=1:size(GelImage,1);	%Cycle through the bands lines and forming bands final values
	    fprintf(fidVal,'%g\t',BandVal(Position,:));
	    fprintf(fidPoints,'%g\t',BandPoints(Position,:));
	    fprintf(fidVal,'\n');
	    fprintf(fidPoints,'\n');
	    
	    if PaperBands==1	%Paper bands are present
		fprintf(fidProt,'%g\t',BandValFin(Position,2:2:BandsNumb));
	    else	%No paper bands
		fprintf(fidProt,'%g\t',BandValFin(Position,1:BandsNumb));
	    end
	    fprintf(fidProt,'\n');
	end
	fclose(fidProt);
	fclose(fidVal);
	fclose(fidPoints);
    end
    
    
end
beep;
disp('All the tasks finished');